(ns six.core
  (:require [clojure.edn :as edn])
  (:gen-class))

(defn next-gen
  [gen]
  (map #(cond (= 6 %)
              (+ (nth gen 7) (first gen))
              (= 8 %)
              (first gen)
              :else
              (nth gen (inc %))) ;; disgusting
       (range 9)))

(defn gen-cycle
  [gen left]
  (if (<= left 0)
    gen
    (recur (next-gen gen) (dec left))))

(defn breed
  [cohort num-gens]
  (let [freqs (->> (slurp cohort)
                   (re-seq #"[0-9]+")
                   (map edn/read-string)
                   (frequencies))
        first-gen (map #(get freqs % 0) (range 9))]
    (gen-cycle first-gen num-gens)))

(defn -main
  [& args]
    (println (->> (if (nil? args) 80 (edn/read-string (first args)))
                  (breed *in*)
                  (reduce +))))
